import os
import time
# pip3 install pynput
# pip install pynput
from pynput import keyboard
from pynput.keyboard import Key

SCENE_WIDTH = 11
SCENE_HEIGHT = 15


class Position2D(object):
    def __init__(self, val_x, val_y, is_check_scene=True):
        super().__init__()
        self.__is_check_scene = is_check_scene
        self.__x = val_x
        self.__y = val_y

    @property
    def x(self): # get_x
        return self.__x

    @x.setter
    def x(self, val): # set_x
        if not self.__is_check_scene or 0 <= val < SCENE_WIDTH:
            self.__x = val

    @property
    def y(self): # get_y
        return self.__y

    @y.setter
    def y(self, val):  # set_y
        if not self.__is_check_scene or 0 <= val < SCENE_HEIGHT:
            self.__y = val


class Element(object):
    def __init__(self):
        super().__init__()
        self._position = Position2D(0, 0)
        self._char = '⬜️'

    @property
    def char(self):
        return self._char

    @property
    def position(self):
        return self._position

    @position.setter
    def position(self, pos):
        self._position = pos

    def draw(self, scene):
        pos_x = int(self.position.x)
        pos_y = int(self.position.y)
        scene[pos_y][pos_x] = self.char

    def update(self, delta_time):
        pass

    def check_collision(self, other):
        pass


class Wall(Element):
    def __init__(self, position): # constructor
        super().__init__()
        self._char = '🏛'
        self._position = position


class MovableElement(Element):
    def __init__(self): # constructor
        super().__init__()
        self._char = '🛸'
        self._speed = 1.0
        self._direction = Position2D(0, 0, is_check_scene=False)

    def update(self, delta_time):
        #TODO
        pass

    def left(self):
        #TODO
        pass

    def right(self):
        #TODO
        pass

    def up(self):
        #TODO
        pass

    def down(self):
        #TODO
        pass

    def check_collision(self, other):
        is_collision = False
        #TODO
        return is_collision

class Player(MovableElement):
    def __init__(self):
        super().__init__()
        self._char = '🚀'

is_game_running = True

pos_middle = Position2D(
    val_x=int(SCENE_WIDTH/2)-1,
    val_y=int(SCENE_HEIGHT/2)-1
)
#TODO

elements = [
]


# main game loop
while is_game_running:

    cmd_clear = 'clear'
    if os.name == 'nt':
        cmd_clear = 'cls'
    os.system(cmd_clear)

    scene = []
    for i in range(SCENE_HEIGHT): # 0...14
        columns = []
        for j in range(SCENE_WIDTH):
             columns.append('⬛️')
        scene.append(columns)

    #TODO draw elements

    scene_lines = []
    for line in scene:
        str_line = ''.join(line)
        scene_lines.append(str_line)
    str_scene = '\n'.join(scene_lines)
    print('')
    print(str_scene)

    delay = 0.5 # seconds
    timestamp = time.time()

    with keyboard.Events() as events:
        key = events.get(delay)

        if key is not None: # key != null
            key_code = key.key
            if key_code == Key.left:
                pass #TODO
            elif key_code == Key.right:
                pass #TODO
            elif key_code == Key.up:
                pass #TODO
            elif key_code == Key.down:
                pass #TODO
            elif key_code == Key.esc:
                is_game_running = False
                break
            elif key_code == Key.space:
                pass #TODO


    dt = delay - (time.time() - timestamp)
    if dt > 0:
        time.sleep(dt)

    dt = time.time() - timestamp

    #TODO update elements
    #TODO calculate collisons
